// Kozak's SMS module for KKJConv V1.1 by N's LAB  Copyright (C) 2007 by Nobumichi Kozawa
import javax.microedition.lcdui.*;
//import javax.microedition.midlet.MIDlet;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
import javax.microedition.rms.*;
import javax.microedition.pim.*;
import javax.wireless.messaging.*;
import java.util.*;
import java.io.*;

public class SendSMS implements CommandListener
{
    private final Command CMD_BACK = new Command("戻る", Command.BACK, 1);
    private final Command CMD_NAME = new Command("名前の確認", Command.SCREEN, 1);
    private final Command CMD_CONTACT = new Command("電話帳", Command.SCREEN, 2);
    private final Command CMD_RECENT = new Command("良く使うあて先", Command.SCREEN, 3);
    private final Command CMD_SEND = new Command("送る", Command.SCREEN, 4);
    private final Command CMD_SENT = new Command("送信済みSMS", Command.SCREEN, 5);

    private Display disp;
    private Displayable homeScreen;
    private Form smsForm;
    private TextField tfPhoneNumber;
    private StringItem siFormattedName;
    private KKJConv kkj;
    private String sPhoneNumber = "";
    private String sFormattedName = "";
    private String sTempPhoneNumber;
    private String[] saPhoneNumber;
    private String[] saFormattedName;
    private final static String enc = "UTF-8";
    private final int iNumberOfPhoneCache = 10;
    private List contactsList;
    private List recentList;
    private boolean bAutoName, bConfirm;
    private String sSentFolder;
    private int iSMSSent;

    public SendSMS(Display adisp, Displayable ahome, KKJConv akkj) {
        disp = adisp;
        homeScreen = ahome;
        kkj = akkj;
        saPhoneNumber = new String[iNumberOfPhoneCache];
        saFormattedName = new String[iNumberOfPhoneCache];
        loadPhoneNumberCache();
        smsForm = new Form("SMS送信");
        tfPhoneNumber = new TextField("あて先電話番号", "", 30, TextField.PHONENUMBER);
        smsForm.append(tfPhoneNumber);
        siFormattedName = new StringItem("あて先の名前", "", Item.PLAIN);
        smsForm.append(siFormattedName);
        smsForm.addCommand(CMD_BACK);
        smsForm.addCommand(CMD_SEND);
        smsForm.addCommand(CMD_NAME);
        smsForm.addCommand(CMD_RECENT);
        smsForm.addCommand(CMD_SENT);
        if (0 == (0x04 & kkj.bSms)) smsForm.addCommand(CMD_CONTACT);
        smsForm.setCommandListener(this);
        bAutoName = (0 == (0x01 & kkj.bSms));
        bConfirm = (0 == (0x02 & kkj.bSms));
        loadConfig();
    }

    public void disp() {
        setPhoneNumber();
        if (2 == iSMSSent) {
            Alert smsInfo = new Alert("SMS送信済みフォルダー");
            smsInfo.setTimeout(5000);
            smsInfo.setType(AlertType.ERROR);
            smsInfo.setString("SMS送信に先立ちフォルダーの設定を行ってください。KKJSetupで設定を変更することもできます。");
            setup.SMSSetup smssetup = new setup.SMSSetup(kkj, smsForm, smsInfo, kkj.bSonyEricsson);
            smssetup.disp();
        } else {
            disp.setCurrent(smsForm);
        }
    }

    public void commandAction(Command c, Displayable d) {
        if (c == CMD_BACK) {
            if (d == smsForm) disp.setCurrent(homeScreen);
            else disp.setCurrent(smsForm);
        } else if (c == CMD_NAME) {
            sPhoneNumber = tfPhoneNumber.getString().trim();
            if (checkPhoneNumber(sPhoneNumber)) {
                new Thread(new Runnable() {
                    public void run() {
                        sFormattedName = getFormattedName(sPhoneNumber);
                        siFormattedName.setText(sFormattedName);
                    }
                }).start();
            }
        } else if (c == CMD_SENT) {
            if (2 == iSMSSent) loadConfig();
            if (1 == iSMSSent) {
                SMSSentBox sbox = new SMSSentBox(kkj, smsForm, sSentFolder);
                sbox.disp();
            }
        } else if (c == CMD_RECENT) {
            if (null == recentList) {
                recentList = new List("良く使うあて先", Choice.IMPLICIT);
                recentList.addCommand(CMD_BACK);
                recentList.setCommandListener(this);
            }
            recentList.deleteAll();
            for (int i = 0; i < iNumberOfPhoneCache; i++) {
                if (checkPhoneNumber(saPhoneNumber[i])) {
                    recentList.insert(i, saFormattedName[i] + ", " + saPhoneNumber[i], null);
                }
            }
            for (int i = 0; i < recentList.size(); i++) recentList.setFont(i, kkj.font);
            disp.setCurrent(recentList);
        } else if (c == List.SELECT_COMMAND) {
            if (d == recentList) {
                setPhoneNumber(((List)d).getSelectedIndex());
            } else {
                String item = ((List)d).getString(((List)d).getSelectedIndex());
                int i = item.lastIndexOf(',');
                if (checkPhoneNumber(item.substring(i + 1))) {
                    tfPhoneNumber.setString(sPhoneNumber = item.substring(i + 1));
                    siFormattedName.setText(sFormattedName = item.substring(0, i));
                }
            }
            disp.setCurrent(smsForm);
        } else if (c == CMD_CONTACT) {
            if (null == contactsList) {
                contactsList = new List("電話帳", Choice.IMPLICIT);
                contactsList.addCommand(CMD_BACK);
                contactsList.setCommandListener(this);
                new Thread(new Runnable() {
                    public void run() {
                        addContactsList();
                    }
                }).start();
            }
            disp.setCurrent(contactsList);
        } else if (c == CMD_SEND) {
            sTempPhoneNumber = sPhoneNumber;
            sPhoneNumber = tfPhoneNumber.getString().trim();
            if (null == sPhoneNumber || 0 == sPhoneNumber.length()) return;
            smsForm.setTitle("送信中");
            new Thread(new Runnable() {
                public void run() {
                    try {
                        if (0 != sPhoneNumber.compareTo(sTempPhoneNumber)) {
                            sFormattedName = (bAutoName) ? getFormattedName(sPhoneNumber) : "";
                            siFormattedName.setText(sFormattedName);
                        }

                        putPhoneNumberToCache();
                        storePhoneNumberCache();

                        final String addr = "sms://" + sPhoneNumber;
                        final MessageConnection conn = (MessageConnection) Connector.open(addr);
                        final TextMessage msg = (TextMessage)conn.newMessage(MessageConnection.TEXT_MESSAGE);

                        StringBuffer msgBody = new StringBuffer();
                        String msgBodyText = (homeScreen == KKJConv.edit) ? kkj.sbKakutei.toString() : kkj.getTbText();

                        char c;
                        for (int i = 0; i < msgBodyText.length(); i++) {
                            c = msgBodyText.charAt(i);
                            if (kkj.cParaSepa == c) {
                                msgBody.append('\r');
                                msgBody.append('\n');
                            } else {
                                msgBody.append(c);
                            }
                        }

                        msg.setPayloadText(msgBody.toString());
                        
                        //saveSMSText();

                        conn.send(msg);
                        conn.close();
                        saveSMSText();

                        disp.setCurrent(homeScreen);
                        if (bConfirm) {
                            smsForm.setTitle("送信完了");
                               Alert smsComp = new Alert("SMS送信完了");
                               smsComp.setTimeout(5000);
                               smsComp.setType(AlertType.INFO);
                               smsComp.setString(sFormattedName + ", " + sPhoneNumber + "へSMS送信完了しました。");
                               disp.setCurrent(smsComp);
                           }
//                           putPhoneNumberToCache();
//                           storePhoneNumberCache();
                    } catch (Exception e) {//java.io.IOException e) {
                        smsForm.setTitle("SMS送信");
        //                e.printStackTrace();
                           Alert smsErr = new Alert("SMS Error");
                           smsErr.setTimeout(5000);
                           smsErr.setType(AlertType.ERROR);
                           smsErr.setString("" + e);
                           disp.setCurrent(smsErr);
                    }
                }
            }).start();
        }
    }

    private synchronized void saveSMSText() {
        if (2 == iSMSSent) loadConfig();
        if (1 == iSMSSent) {
            String fname;
            StringBuffer sb = new StringBuffer();
            String temp = (new Date()).toString().trim();
            String yyyy = temp.substring(temp.length() - 4);
            String mon = SMSSentBox.getMonth(temp.substring(4, 7));
            String daytime = temp.substring(8, 19);

               fname = SMSSentBox.getCurrent(sSentFolder, yyyy);
            FileConnection fc = null;
            OutputStream os = null;
            try {
                fc = (FileConnection)Connector.open("file:///" + sSentFolder + fname, Connector.READ_WRITE);
                   if (!fname.endsWith("999") && fc.fileSize() > 31000) {
                       int num = 1 + Integer.parseInt(fname.substring(12));
                       temp = "000" + String.valueOf(num);
                       fname = "KKJSMS." + yyyy + "." + temp.substring(temp.length() - 3);
                       fc.close();
                    fc = (FileConnection)Connector.open("file:///" + sSentFolder + fname, Connector.READ_WRITE);
                   }
                if (!fc.exists()) fc.create();
                os = fc.openOutputStream(fc.fileSize());
                OutputStreamWriter osw = new OutputStreamWriter(os, enc);
                sb.append(mon + "/" + daytime + "\t" + sPhoneNumber + "\t" + sFormattedName + "\t");
                   if (homeScreen == kkj.edit) sb.append(kkj.sbKakutei.toString());    // 漢字入力画面
                   else sb.append(kkj.getTbText());                                    // コピペ画面
                   sb.append("\n");
                osw.write(sb.toString(), 0, sb.length());
            } catch (Exception e) {
                e.printStackTrace();
            } finally {
                try {
                    if (null != os) os.close();
                    if (null != fc) fc.close();
                } catch (IOException e) {
                }
            }
        }
    }

    private void loadConfig() {
        RecordStore rsc = null;
        String sPath = null;
        byte[] ba;

        iSMSSent = 0;
        try {
            rsc = RecordStore.openRecordStore("KKJSMS", false);
            ba = rsc.getRecord(1);
            sPath = new String(ba, "UTF-8");
        } catch (Exception e) {
            iSMSSent = 2;
        } finally {
            try {
                if (null != rsc) rsc.closeRecordStore();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        if (2 != iSMSSent) {
            if (null == sPath) {
                iSMSSent = 2;
            } else {
                iSMSSent = (sPath.startsWith("1")) ? 1 : 0;
                sSentFolder = sPath.substring(1);
            }
        }
    }

    private boolean checkPhoneNumber(String num) {
        int i = 0;

        if (null == num || num.length() == 0) return false;
        if (num.startsWith("+")) i = 1;
        for (; i < num.length(); i++) {
            if (!Character.isDigit(num.charAt(i))) return false;
        }
        return true;
    }

    private void addContactsList() {
        String sVal;
        String sFName;
        int iList = 0;

        String[] lists = PIM.getInstance().listPIMLists(PIM.CONTACT_LIST);
        if (lists.length <=0) return;
        try {
            PIMList list = PIM.getInstance().openPIMList(PIM.CONTACT_LIST, PIM.READ_ONLY, lists[0]);
            if (list.isSupportedField(Contact.TEL)) {
                Enumeration items = list.items();
                whileLoop:
                while(items.hasMoreElements()) {
                    PIMItem pitem = (PIMItem)items.nextElement();
                    sFName = getFormattedName(list, pitem);
                    for (int i = 0; i < pitem.countValues(Contact.TEL); i++) {
                        sVal = pitem.getString(Contact.TEL, i);
                        if ((sVal != null) && (sVal.length() != 0)) {
                            contactsList.insert(iList, sFName + "," + sVal, null);
                            contactsList.setFont(iList, kkj.font);
                            iList++;
                        }
                    }
                } // End of while
            }
            list.close();
        } catch (PIMException e) {
        }
    }

    private String getFormattedName(String tel) {
        String sVal;
        String sFName = "";

        String[] lists = PIM.getInstance().listPIMLists(PIM.CONTACT_LIST);
        if (lists.length <=0) return null;

        try {
            PIMList list = PIM.getInstance().openPIMList(PIM.CONTACT_LIST, PIM.READ_ONLY, lists[0]);
            if (list.isSupportedField(Contact.TEL)) {
                Enumeration items = list.items(tel);    // most likely only one item will be returned
//                Enumeration items = list.items();
                whileLoop:
                while(items.hasMoreElements()) {
                    PIMItem pitem = (PIMItem)items.nextElement();
                    for (int i = 0; i < pitem.countValues(Contact.TEL); i++) {
                        sVal = pitem.getString(Contact.TEL, i);
                        if ((sVal != null) && (sVal.length() != 0)) {
                            if (0 == sVal.compareTo(tel)) {            // Tel number macthed!
                                sFName = getFormattedName(list, pitem);
                                break whileLoop;
                            }
                        }
                    }
                } // End of while
            }
            list.close();
        } catch (PIMException e) {
        }
        return sFName;
    }

    private String getFormattedName(PIMList list, PIMItem item) {
        String name = "";

        if (list.isSupportedField(Contact.FORMATTED_NAME)) {
            if (item.countValues(Contact.FORMATTED_NAME) != 0) {
                name = item.getString(Contact.FORMATTED_NAME, 0).trim();
                if (name.length() > 0) {
                    return name;
                }
            }
        }
        // if FORMATTED_NAME is not available
        if (list.isSupportedField(Contact.NAME)) {
            if (item.countValues(Contact.NAME) != 0) {
                String[] a = item.getStringArray(Contact.NAME, 0);
                if (a != null) {
                    StringBuffer sb = new StringBuffer();
                    if (a[Contact.NAME_FAMILY] != null) {
                        sb.append(a[Contact.NAME_FAMILY]);
                    }
                    if (a[Contact.NAME_GIVEN] != null) {
                        if (sb.length() > 0) {
                            sb.append(" ");
                        }
                        sb.append(a[Contact.NAME_GIVEN]);
                    }
                    name = sb.toString().trim();
                }
            }
        }
        return name;
    }

    private void setPhoneNumber() {
        if (0 == kkj.sSMSNumber.compareTo("")) setPhoneNumber(0);
        else {
            tfPhoneNumber.setString(sPhoneNumber = kkj.sSMSNumber);
            siFormattedName.setText(sFormattedName = kkj.sSMSName);
        }
    }

    private void setPhoneNumber(int i) {
        if (0 <= i && i < iNumberOfPhoneCache) {
            if (checkPhoneNumber(saPhoneNumber[i])) {
                tfPhoneNumber.setString(sPhoneNumber = saPhoneNumber[i]);
                siFormattedName.setText(sFormattedName = saFormattedName[i]);
            }
        }
    }

    private void putPhoneNumberToCache() {
        int i;

        for (i = 0; i < iNumberOfPhoneCache; i++) {
            if (null != saPhoneNumber[i]) {
                if (0 == sPhoneNumber.compareTo(saPhoneNumber[i])) {
                    break;
                }
            }
        }
        for (i = i - 1; i >= 0; i--) {
            if (i + 1 < iNumberOfPhoneCache) {
                saPhoneNumber[i + 1] = saPhoneNumber[i];
                saFormattedName[i + 1] = saFormattedName[i];
            }
        }
        saPhoneNumber[0] = sPhoneNumber;
        saFormattedName[0] = sFormattedName;
    }

    private void loadPhoneNumberCache() {
        byte[] ba;
        int iPos, iPhone, iName, i;

        iPhone = iName = iPos = i = 0;
        RecordStore rsw = null;
        try {
            rsw = RecordStore.openRecordStore("smsPhoneNumber", false);
            ba = rsw.getRecord(1);
            String s = new String(ba, enc);
            while(true) {
                i = s.indexOf("\n", iPos);
                if (i < 0) break;
                if (iPhone == iName) {
                    saPhoneNumber[iPhone] = s.substring(iPos, i);
                    iPhone++;
                } else {
                    saFormattedName[iName] = s.substring(iPos, i);
                    iName++;
                    if (iName >= iNumberOfPhoneCache) break;
                }
                iPos = i + 1;
                if (iPos >= s.length()) break;
            }
        } catch (Exception e) {
        } finally {
            try {
                if (null != rsw) rsw.closeRecordStore();
            } catch (Exception e) {
            }
        }
    }

    private void storePhoneNumberCache() {
        byte[] ba;
        StringBuffer sb = new StringBuffer();

        for (int i = 0; i < iNumberOfPhoneCache; i++) {
            if (checkPhoneNumber(saPhoneNumber[i])) {
                sb.append(saPhoneNumber[i].trim() + "\n");
                if (null == saFormattedName[i]) sb.append("\n");
                else sb.append(saFormattedName[i].trim() + "\n");
            } else {
                break;
            }
        }

        if (sb.length() > 0) {
            try {
                try {
                    RecordStore.deleteRecordStore("smsPhoneNumber");
                } catch (RecordStoreNotFoundException e) {
                }
                RecordStore rsw = RecordStore.openRecordStore("smsPhoneNumber", true);
                ba = sb.toString().getBytes(enc);
                rsw.addRecord(ba, 0, ba.length);
                rsw.closeRecordStore();
            } catch (Exception e) {
            }
        }
    }
}
