// Kozak's Special Character Selection panel V1.3 N's LAB  Copyright (C) 2006 by Nobumichi Kozawa
//import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
//import javax.microedition.rms.*;

public class SpeCharSel extends Canvas
{
    private KKJConv kkj;
    public int iScreenWidth, iScreenHeight;
    private Font font;
    private int iFh, iFw, iFw2, iFdiff, iCol, iRow, iBoxX, iBoxY, iBoxW, iBoxH;
    private int iLeft, iRight, iUp, iDown;
    public static char[] cHalf = {'!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/', ':', ';', '<', '=', '>', '?', '@', '[', '\\', ']', '^', '_', '`', '{', '|', '}', '~'};
    public static char[] cFull = {'！', '”', '＃', '＄', '％', '＆', '’', '（', '）', '＊', '＋', '，', '－', '．', '／', '：', '；', '＜', '＝', '＞', '？', '＠', '［', '＼', '］', '＾', '＿', '‘', '｛', '｜', '｝', '～'};
    public static char[] cFull2 = {'「', '」', '、', '。', '￥', '・' , '○', '×', '★', '☆', '【', '】', '㈱', '㈲', '〒', '←', '↑', '→', '↓', '々','㌧', '〆','♪','《','》','§','∞','∴','∵','℡','♂','♀'};
    public int iMode = 1;    // 0 - numeric, 1 - hankakum, 2 - zenkaku, 3 - zenkaku2
    private int iCursor = 0, iCharLen;
    private int iSpChr, iBGColor, iBGColor2, iChrSel, iBGChrSel, iFontColor, iBorderColor;

    public SpeCharSel(KKJConv k)
    {
        kkj = k;
        switch (kkj.bSPFont) {
            case 0 :
                font = Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_LARGE);
                break;
            case 2 :
                font = Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_SMALL);
                break;
            default :
                font = Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_MEDIUM);
        }
        iScreenWidth = getWidth();
        iScreenHeight = getHeight();
        iFh = font.getHeight();
        iFw = font.charWidth('＿');
        iFw2 = font.charWidth('_');
        iFdiff = (iFw - iFw2) / 2;
        iCol = (iScreenWidth - 10 > (iFw + 4) * 8) ? 8 : 4;
        iRow = 1 + (iScreenHeight - 10) / (iFh + 4);
        if (iRow > (40 / iCol) + 1) iRow = 1 + 32 / iCol;
        iBoxW = iCol * (iFw + 5) + 2;
        iBoxH = iRow * (iFh + 5) + 2;
        iBoxX = (iScreenWidth - iBoxW) / 2;
        iBoxY = (iScreenHeight - iBoxH) / 2;
        if (kkj.bSonyEricsson || kkj.bE7_00 || kkj.bN97mini) {
            iLeft = -3;
            iRight = -4;
            iUp = -1;
            iDown = -2;
        } else {
            if (kkj.bBB) {
                iUp = getKeyCode(Canvas.LEFT);
                iDown = getKeyCode(Canvas.RIGHT);
                iLeft = getKeyCode(Canvas.UP);
                iRight = getKeyCode(Canvas.DOWN);
            } else {
                iLeft = getKeyCode(Canvas.LEFT);
                iRight = getKeyCode(Canvas.RIGHT);
                iUp = getKeyCode(Canvas.UP);
                iDown = getKeyCode(Canvas.DOWN);
            }
        }
        iCharLen = charLen(iMode);
        setting();
    }

    private void setting()
    {
        iBGColor = kkj.iBGColor;
        if (kkj.bBB) {
            iBGColor2 = 0x00333333;
            iChrSel = 0x00000000;
            iBGChrSel = 0x00FFFFFF;
            iFontColor = 0x00FFFFFF;
            iBorderColor = 0x00C0C0C0;
        } else if (kkj.bCN) {
            iBGColor2 = 0x00FF0000;
            iChrSel = 0x00FF0000;
            iBGChrSel = 0x0000FFFF;
            iFontColor = 0x00FF0000;
            iBorderColor = 0x00FF0000;
        } else {
            iBGColor2 = 0x00336699;
            iChrSel = 0x00000000;
            iBGChrSel = 0x00B0C4DE; // lightsteelblue
            iFontColor = 0x00FFFFFF;
            iBorderColor = 0x00C0C0C0;
        }
    }

    private int charLen(int iMode)
    {
        int iLen;

        switch (iMode)
        {
            case 1 : iLen = cHalf.length; break;
            case 2 : iLen = cFull.length; break;
            case 3 : iLen = cFull2.length; break;
            default : iLen = 0;
        }
        return iLen;
    }

    public void keyRepeated(int keyCode)
    {
        if (keyCode != 0x2f) keyPressed(keyCode);
    }

    public void keyPressed(int keyCode)
    {
        char ch;
        switch (keyCode)
        {
            case -5 :
            case -42 :            // d6, P990i
            case 0x0a :
            case 0x0d :
            case 0x35 :
            case 64:            // @ for E7-00
            case 71:
            case 103:
                switch (iMode) {
                    case 1 : ch = cHalf[iCursor]; break;
                    case 2 : ch = cFull[iCursor]; break;
                    case 3 : ch = cFull2[iCursor]; break;
                    default : ch = ' ';
                }
                kkj.entSpeChar(ch, true);
                break;
            default :
                if ((0x2f == keyCode && !kkj.bE61) || ((0x69 == keyCode || 0x61 == keyCode || 0x7a == keyCode) && kkj.bE61)) {
                    ch = (0 == kkj.iMode || 3 == kkj.iMode || 5 == kkj.iMode) ? '／' : '/';
                    kkj.entSpeChar(ch, false);
                } else if (keyCode == kkj.iSpChr || 0x20 == keyCode || 0x30 == keyCode || '*' == keyCode) {
                    iMode++;
                    if (3 < iMode) iMode = 1;
                    iCharLen = charLen(iMode);
                } else if (keyCode == 72 || keyCode == 104 || keyCode == iRight || 0x36 == keyCode) {
                    iCursor++;
                    if (iCursor >= iCharLen) iCursor = 0;
                } else if (keyCode == 70 || keyCode == 102 || keyCode == iLeft || 0x34 == keyCode) {
                    iCursor--;
                    if (iCursor < 0) iCursor = iCharLen - 1;
                } else if (keyCode == 84 || keyCode == 116 || keyCode == iUp || 0x32 == keyCode || (kkj.bSonyEricsson && -38 == keyCode)) {
                    iCursor -= iCol;
                    if (iCursor < 0) iCursor += iCol * (iRow - 1);
                } else if (keyCode == 66 || keyCode == 98 || keyCode == iDown || 0x38 == keyCode || (kkj.bSonyEricsson && -39 == keyCode)) {
                    iCursor += iCol;
                    if (iCursor >= iCharLen) iCursor -= iCol * (iRow - 1);
                } else if (keyCode == 8 || keyCode == -8 || '#' == keyCode) {
                    kkj.disp.setCurrent(kkj.edit);
                }
        }
        this.repaint();
    }

    public void paint(Graphics g)
    {
        int i, j, ix, iy, iSel;
        String mojiShu;
        g.setFont(font);
        g.setColor(iBGColor2);
           g.fillRect(0, 0, iScreenWidth, iScreenHeight);

        g.setColor(iBGColor);        // NAVY
        g.fillRect(iBoxX, iBoxY, iBoxW, iBoxH);
        g.setColor(iBorderColor);        // silver
        g.drawRect(iBoxX + 1, iBoxY + 1, iBoxW - 2, iBoxH - 2);
        g.drawRect(iBoxX, iBoxY, iBoxW, iBoxH);
        for (i = 1; i < iCol; i++) {
            ix = iBoxX + 1 + (iFw + 5) * i;
            g.drawLine(ix, iBoxY + iFh + 6, ix, iBoxY + iBoxH);
        }
        for (i = 1; i < iRow; i++) {
            iy = iBoxY + 1 + (iFh + 5) * i;
            g.drawLine(iBoxX, iy, iBoxX + iBoxW, iy);
        }
        g.setColor(iFontColor);        // WHITE
        switch (iMode) {
            case 1 : mojiShu = "半角"; break;
            case 2 : mojiShu = "全角"; break;
            case 3 : mojiShu = "全角2"; break;
            default : mojiShu = "";
        }
        g.drawString(mojiShu, iBoxX + (iBoxW - font.stringWidth(mojiShu)) / 2, iBoxY + 4, Graphics.LEFT | Graphics.TOP);
        for (i = 0; i < iRow; i++) {
            for (j = 0; j < iCol; j++) {
                iSel = i * iCol + j;
                if (iCursor == iSel) {
                    g.setColor(iBGChrSel);        // lightsteelblue
                    g.fillRect(iBoxX + 2 + j * (iFw + 5), iBoxY + iFh + 7 + i * (iFh + 5), iFw + 4, iFh + 4);
                    g.setColor(iChrSel);
                }
                switch (iMode) {
                    case 1 :
                        if (cHalf.length > iSel)
                            g.drawChar(cHalf[iSel], iBoxX + 4 + iFdiff + j * (iFw + 5) , iBoxY + iFh + 10 + i * (iFh + 5), Graphics.TOP | Graphics.LEFT);
                        break;
                    case 2 :
                        if (cFull.length > iSel)
                            g.drawChar(cFull[iSel], iBoxX + 4 + j * (iFw + 5) , iBoxY + iFh + 10 + i * (iFh + 5), Graphics.TOP | Graphics.LEFT);
                        break;
                    case 3 :
                        if (cFull2.length > iSel)
                            g.drawChar(cFull2[iSel], iBoxX + 4 + j * (iFw + 5) , iBoxY + iFh + 10 + i * (iFh + 5), Graphics.TOP | Graphics.LEFT);
                        break;
                    default :
                }
                if (iCursor == iSel) g.setColor(iFontColor);
            }
        }
    }
}